/*
 * ${license.title}
 * Copyright (C) 2022 ${license.owner}
 * ${license.mailto}
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

//
// Created by webpigeon on 05/06/22.
//

#ifndef FGGL_GFX_PHONG_HPP
#define FGGL_GFX_PHONG_HPP

#include "fggl/math/types.hpp"

namespace fggl::gfx {

	struct PhongMaterial {
		constexpr static const char* name = "gfx::material";
		math::vec3 ambient;
		math::vec3 diffuse;
		math::vec3 specular;
		float shininess;
	};

	enum class LightType {
			Directional,
			Point,
			Spot
	};

	struct Light {
		constexpr static const char* name = "gfx::light";
		LightType type;
		math::vec3 position;

		// colours
		math::vec3 ambient;
		math::vec3 diffuse;
		math::vec3 specular;

		// distance data
		math::vec3 falloffs; // (constant, linear, quadratic)
		float cutOff;
		float outerCutOff;
	};

} // namesapce fggl::gfx

#endif //FGGL_GFX_PHONG_HPP
